/*#########################################################################
#                                                                         #
#   Simple script shamelessly recopied from:                              #
#                                                                         #
#   Copyright                                                             #
#                                                                         #
#   (C)  2009 Àlvar Cuevas i Fajardo <alvar@cuevas.cat>                   #
#   (C)  2008 Eirik Johansen Bjørgan  <eirikjbj@gmail.com>                #
#   (C)  2007, 2008 Nikolaj Hald Nielsen  <nhnFreespirit@gmail.com>       #
#   (C)  2008 Peter ZHOU <peterzhoulei@gmail.com>                         #
#   (C)  2008 Mark Kretschmann <kretschmann@kde.org>                      #
#   (C)  2009 Stephen Dunn <dunnfamily@orcon.net.nz>                      #
#                                                                         #
#   This program is free software; you can redistribute it and/or modify  #
#   it under the terms of the GNU General Public License as published by  #
#   the Free Software Foundation; either version 2 of the License, or     #
#   (at your option) any later version.                                   #
#                                                                         #
#   This program is distributed in the hope that it will be useful,       #
#   but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#   GNU General Public License for more details.                          #
#                                                                         #
#   You should have received a copy of the GNU General Public License     #
#   along with this program; if not, write to the                         #
#   Free Software Foundation, Inc.,                                       #
#   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.         #
##########################################################################*/

Importer.loadQtBinding("qt.core");
Importer.loadQtBinding("qt.gui");
Importer.loadQtBinding( "qt.xml" );

function Station( name, url, description )
{
    this.name = name;
    this.url = url;
    this.description = description;
}


categories = new Object;

categories["Radio New Zealand"]=new Array (
    new Station("Radio New Zealand National", "http://www.radionz.co.nz/__data/assets/audio_item/0019/8065/national.asx", "Radio New Zealand National"),
    new Station("Radio New Zealand International", "http://www.radionz.co.nz/__data/assets/audio_item/0019/8074/rnzi.asx", "Radio New Zealand International"),
    new Station("Radio New Zealand Parliament", "http://www.radionz.co.nz/__data/assets/audio_item/0011/340598/nzparliament.asx", "Radio New Zealand Parliament"),
    new Station("Radio New Zealand Concert", "http://www.radionz.co.nz/__data/assets/audio_item/0017/8072/concert.asx", "Radio New Zealand Concert")
);

categories["MoreFM"]=new Array (
    new Station("Manawatu MoreFM", "http://boombox.inspire.net.nz:8020/listen.pls", "MoreFM Manawatu"),
    new Station("Auckland MoreFM", "http://www1.streaming.net.nz/meta/tvworks-morefm-akl-32.asx", "MoreFM Auckland"),
    new Station("Hamilton MoreFM", "http://www1.streaming.net.nz/meta/tvworks-morefm-ham.asx", "MoreFM Hamilton"),
    new Station("Northland MoreFM", "http://streaming.mediaworks.co.nz/morefmwhg", "MoreFM Northland"),
    new Station("Wairarapa MoreFM", "http://streaming.mediaworks.co.nz/morefm2", "MoreFM Wairarapa"),
    new Station("Wellington MoreFM", "http://streaming.mediaworks.co.nz/morefmwtn", "MoreFM Wellington"),
    new Station("Canterbury MoreFM", "http://www1.streaming.net.nz/meta/morefm-chc-32.asx", "MoreFM Canterbury"),
    new Station("Dunedin MoreFM", "http://streaming.mediaworks.co.nz/morefmdun", "MoreFM Dunedin"),
    new Station("Hawkes Bay MoreFM", "http://streaming.mediaworks.co.nz/morefm1", "MoreFM Hawkes Bay")
);

categories["BSport"]=new Array (
    new Station("BSport", "mms://dragons.catalyst.net.nz/trackside-radio", "BSport")
);

categories["Coast Timeless Music"]=new Array (
    new Station("Coast Timeless Music Auckland", "http://www.newstalkzb.co.nz/audioasx.asp?whichbrand=coastAK&pass=30809", "National network targeting baby boomers<br\><br\>thecoast.net.nz"),
    new Station("Coast Timeless Music Christchurch", "http://www.newstalkzb.co.nz/audioasx.asp?whichbrand=coastCH&pass=25820", "National network targeting baby boomers<br\><br\>thecoast.net.nz"),
    new Station("Coast Timeless Music Wellington", "http://www.newstalkzb.co.nz/audioasx.asp?whichbrand=coastWN&pass=44355", "National network targeting baby boomers<br\><br\>thecoast.net.nz")
);

categories["Easy Mix"]=new Array (
    new Station("Easy Mix", "http://www.newstalkzb.co.nz/audioasx.asp?whichbrand=easymix&pass=30985", "Easy Mix")
);

categories["Flava"]=new Array (
    new Station("Flava", "http://www.newstalkzb.co.nz/audioasx.asp?whichbrand=Flava&pass=21555", "Flava")
);

categories["George FM"]=new Array (
    new Station("George FM", "http://media.georgefm.co.nz/playlist/georgefm128.m3u", "George FM"),
    new Station("George FM Jazz", "http://media.georgefm.co.nz/playlist/Georgejazz128.m3u", "George FM Jazz"),
    new Station("George FM Classic Dance", "http://media.georgefm.co.nz/playlist/GCD128.m3u", "George FM Classis Dance"),
    new Station("Base FM", "http://media.georgefm.co.nz/playlist/basefm128.m3u", "Base FM")
);

categories["Kiwi FM"]=new Array (
    new Station("Kiwi FM", "http://streaming.mediaworks.co.nz/kiwifmakl_high", "Kiwi FM")
);

categories["Newstalk ZB"]=new Array (
    new Station("Newstalk ZB Auckland", "http://www.newstalkzb.co.nz/audioasx.asp?whichbrand=newstalkzbAK&pass=48812", "News and talkback, national network<br\><br\>newstalkzb.co.nz"),
    new Station("Newstalk ZB Wellington", "http://www.newstalkzb.co.nz/audio2/newstalkzbwn.asx", "News and talkback, national network<br\><br\>newstalkzb.co.nz"),
    new Station("Newstalk ZB Christchurch", "http://www.newstalkzb.co.nz/audio2/newstalkzbch.asx", "News and talkback, national network<br\><br\>newstalkzb.co.nz")
);

categories["Radio Hauraki"]=new Array (
    new Station("Radio Hauraki Classic Rock", "http://www.newstalkzb.co.nz/audioasx.asp?whichbrand=haurakiAK&pass=28391", "Radio Hauraki")
);

categories["Radio Live"]=new Array (
    new Station("Radio Live", "http://www1.streaming.net.nz/meta/tvworks-radiolive.asx", "Radio Live")
);

categories["Radio Sport"]=new Array (
    new Station("Radio Sport", "http://www.newstalkzb.co.nz/audioasx.asp?whichbrand=radiosportAK&pass=20418", "Radio Sport")
);

categories["Solid Gold"]=new Array (
    new Station("Solid Gold FM", "http://www1.streaming.net.nz/meta/tvworks-solid-gold.asx", "Solid Gold FM")
);

categories["The Edge"]=new Array (
    new Station("The Edge", "http://www1.streaming.net.nz/meta/tvworks-edge-akl.asx", "The Edge")    
);

categories["The Rock"]=new Array (
    new Station("The Rock FM", "http://www1.streaming.net.nz/meta/tvworks-rock.asx", "The Rock")
);

categories["ZM"]=new Array (
    new Station("ZM", "http://www.newstalkzb.co.nz/audioasx.asp?whichbrand=zmak&pass=6873", "ZM")
);

categories["Life fm"]=new Array (
    new Station("Life fm", "http://www1.streaming.net.nz/meta/rbg-lifefm.asx", "Life fm")
);

categories["Niu FM"]=new Array (
    new Station("Niu FM", "http://www.niufm.com/site_resources/library/streamtools/util/drag/NiuFM.m3u", "Niu Fm")
);

categories["Rhema"]=new Array (
    new Station("New Zealand's Rhema", "http://www1.streaming.net.nz/meta/rbg-rhema.asx", "New Zealand's Rhema")
);

categories["Southern Star"]=new Array (
    new Station("Southern Star", "http://www1.streaming.net.nz/meta/rbg-sstar.asx", "Southern Star")
);

categories["UGM"]=new Array (
    new Station("Underground Music", "http://www.ugm.co.nz/ugmlive.asx", "Underground Music")
);

categories["Classic Hits"]=new Array (
    new Station("Classic Hits FM", "http://www.newstalkzb.co.nz/audioasx.asp?whichbrand=classichitsAK&pass=6899", "Classic Hits FM")
);

categories["The Breeze"]=new Array (
    new Station("The Breeze Christchurch", "http://streaming.mediaworks.co.nz/breezechch", "The Breeze Christchurch"),
    new Station("The Breeze Auckland", "http://streaming.mediaworks.co.nz/breezeakl", "The Breeze Auckland"),
    new Station("The Breeze Waikato", "http://streaming.mediaworks.co.nz/breezeham", "The Breeze Waikato"),
    new Station("The Breeze Wellington", "http://streaming.mediaworks.co.nz/breezewtn", "The Breeze Wellington")
);

categories["The Zone"]=new Array (
    new Station("The Zone 89X Northland", "http://www.thezonefm.co.nz/stream.asx", "The Zone")
);

categories["bFM"]=new Array (
    new Station("bFM (128bps)", "http://www.95bfm.com/bfm128.m3u", "bFM"),
    new Station("bFM (32bps)", "http://www.95bfm.com/bfm32.m3u", "bFM")
);

categories["Big FM"]=new Array (
    new Station("Big FM", "http://www1.streaming.net.nz/meta/bigradio-stream1.asx", "Big FM")
);

categories["Fleet FM"]=new Array (
    new Station("Fleet FM 88.3 (80kbps)", "http://www.fleetfm.co.nz/FleetBroadband.m3u", "Fleet FM"),
    new Station("Fleet FM 88.3 (32kbps)", "http://www.fleetfm.co.nz/FleetDialUp.m3u", "Fleet FM")
);

categories["Mai FM"]=new Array (
    new Station("Mai FM 88.6", "http://ac1.streaming.net.nz/tvworks-maifmakl", "Mai FM 88.6 Auckland's Hottest Music")
);

categories["Radio 531 PI"]=new Array (
    new Station("Radio 531 PI", "http://www.radio531pi.com/531pi.m3u", "Radio 531 PI")
);

categories["Radio Samoa"]=new Array (
    new Station("Radio Samoa", "http://202.89.145.202:8000/listen.pls", "Radio Samoa")
);

categories["Radio Tarana"]=new Array (
    new Station("Radio Tarana", "http://mms2.streamcom.net/NZrt14oc08", "Radio Tarana, No 1 in Indian Radio")
);

categories["Static"]=new Array (
    new Station("Static AUT Student Radio (broadband)", "http://artsweb.aut.ac.nz:8000/listen.pls", "Static, Auckland University of Technology Student Radio"),
    new Station("Static AUT Student Radio (dialup)", "http://artsweb.aut.ac.nz:8002/listen.pls", "Static, Auckland University of Technology Student Radio")
);

categories["Up FM"]=new Array (
    new Station("Up 107.5 FM (128kbps)", "http://stream.braintrust.co.nz/upfm_ogg_128.m3u", "Up 107.5 FM Auckland"),
    new Station("Up 107.5 FM (32kbps)", "http://stream.braintrust.co.nz/upfm_mp3_32.m3u", "Up 107.5 FM Auckland")
);

categories["Waiheke Radio"]=new Array (
    new Station("Waiheke Radio", "http://210.48.92.7:8000/listen.pls", "Waiheke Island Community Radio<br/><br/>Broadcasting on 107.4FM in Oneroa, Blackpool, and parts of Surfdale, and 88.3FM in Ostend, Palm Beach, and Onetangi<br/><br/>waihekeradio.org.nz")
);

categories["Community Radio Hamilton"]=new Array (
    new Station("Community Radio Hamilton", "http://www.accessradio.org/media/live.php?stream=4", "Community Radio Hamilton, Hamilton, communityradio.co.nz, FM106.7 AM1206")
);

categories["1XX"]=new Array (
    new Station("One Double X", "http://www1.streaming.net.nz/meta/1xx.asx", "One Double X, Eastern Bay of Plenty, 1xx.co.nz, Local radio")
);

categories["BayRock"]=new Array (
    new Station("BayRock", "http://www1.streaming.net.nz/meta/radiobop-bayrock.asx", "BayRock Bay of Plenty<br/><br/>Wanaka 93.0FM<br/>Ohope Beach 99.3FM<br/>Bay of Plenty 97.7FM<br/><br/>bayrock.co.nz")
);

categories["Access Radio Manawatu"]=new Array (
    new Station("Access Radio Manawatu", "http://www.accessradio.org/media/live.php?stream=11", "Manawatu community access radio<br/><br/>999AM<br/><br/>accessmanawatu.co.nz")
);

categories["Radio Control"]=new Array (
    new Station("Radio Control (64kbps)", "http://www.ourregion.co.nz/boombox/radiocontrol64.pls", "Massey University Palmerston North, student radio<br/><br/>99.4FM<br/><br/>radiocontrol.org.nz"),
    new Station("Radio Control (32kbps)", "http://www.ourregion.co.nz/boombox/radiocontrol32.pls", "Massey University Palmerston North, student radio<br/><br/>99.4FM<br/><br/>radiocontrol.org.nz")
);

categories["The VBC"]=new Array (
    new Station("The VBC", "http://202.50.176.139:8000/listen.pls", "Victoria University of Wellington student and community radio<br/><br/>88.3FM<br/><br/>vbc.org.nz")
);

categories["Human FM"]=new Array (
    new Station("Human FM (128kbps)", "http://www.humanfm.co.nz/streaming/streamHigh.mp3.m3u", "Victoria University of Wellington<br/>Commercial free<br/>Student and staff collaboration<br/><br/>88.1FM<br/><br/>humanfm.co.nz"),
    new Station("Human FM (48kbps)", "http://www.humanfm.co.nz/streaming/streamLow.mp3.m3u", "Victoria University of Wellington<br/>Commercial free<br/>Student and staff collaboration<br/><br/>88.1FM<br/><br/>humanfm.co.nz")
);

categories["Radio Active"]=new Array (
    new Station("Radio Active (broadband)", "http://radio.paradise.net.nz:9020/listen.pls", "Wellington<br/><br/>89FM<br/><br/>radioactive.co.nz"),
    new Station("Radio Active (dialup)", "http://radio.paradise.net.nz:9024/listen.pls", "Wellington<br/><br/>89FM<br/><br/>radioactive.co.nz")
);

categories["Wellington Access Radio"]=new Array (
    new Station("Wellington Access Radio", "http://www.accessradio.org/media/live.php?stream=3", "Wellington community radio<br/><br/>783AM<br/><br/>www.accessradio.org.nz")
);

categories["BayRock"]=new Array (
    new Station("BayRock", "http://www1.streaming.net.nz/meta/radiobop-bayrock.asx", "BayRock Bay of Plenty<br/><br/>Wanaka 93.0FM<br/>Ohope Beach 99.3FM<br/>Bay of Plenty 97.7FM<br/><br/>bayrock.co.nz")
);

categories["Access Radio Manawatu"]=new Array (
    new Station("Access Radio Manawatu", "http://www.accessradio.org/media/live.php?stream=11", "Manawatu community access radio<br/><br/>999AM<br/><br/>accessmanawatu.co.nz")
);

categories["Radio Control"]=new Array (
    new Station("Radio Control (64kbps)", "http://www.ourregion.co.nz/boombox/radiocontrol64.pls", "Massey University Palmerston North, student radio<br/><br/>99.4FM<br/><br/>radiocontrol.org.nz"),
    new Station("Radio Control (32kbps)", "http://www.ourregion.co.nz/boombox/radiocontrol32.pls", "Massey University Palmerston North, student radio<br/><br/>99.4FM<br/><br/>radiocontrol.org.nz")
);

categories["The VBC"]=new Array (
    new Station("The VBC", "http://202.50.176.139:8000/listen.pls", "Victoria University of Wellington student and community radio<br/><br/>88.3FM<br/><br/>vbc.org.nz")
);

categories["fresh fm"]=new Array (
    new Station("fresh fm", "http://www.freshfm.net/H1N1edited.mp3", "Community access radio across the top of the South Island<br/><br/>Nelson/Tasman region 104.8FM<br/>Nelson City 95.4FM<br/>Eastern Golden Bay 95.2FM<br/>Blenheim 89.2FM<br/><br/>freshfm.net")
);

categories["pulzar fm"]=new Array (
    new Station("pulzar fm", "mms://87.117.228.28/pulzar", "Christchurch and greater canterbury<br/><br/>105.7FM<br/>Pop, electronica, dance and classic tracks<br/><br/>pulzarfm.co.nz")   
);

categories["RDU 98.5 FM"]=new Array (
    new Station("RDU 98.5 FM", "http://81.171.50.130:9040/listen.pls", "Christchurch, music, opinion, and culture<br/><br/>98.5FM<br/><br/>rdu.org.nz")
);

categories["Plains FM"]=new Array (
    new Station("Plains FM", "http://www.accessradio.org/media/live.php?stream=12", "Canterbury community access radio<br/><br/>96.9FM<br/><br/>plainsfm.org.nz")
);

categories["New Zealand County Radio"]=new Array (
    new Station("New Zealand Country Radio Dunedin", "http://www.countryradionetwork.com/dunedinstream.m3u", "Invercargill 88.4 & 88.7FM<br/>Riverton 88.4 FM<br/>Dunedin 88.7FM<br/>Cromwell 88.7FM<br/>Oamaru 107.7FM<br/><br/>countryradionetwork.com"),
    new Station("New Zealand Country Radio Invercargill", "http://www.countryradionetwork.com/invercargillstream.m3u", "Invercargill 88.4 & 88.7FM<br/>Riverton 88.4 FM<br/>Dunedin 88.7FM<br/>Cromwell 88.7FM<br/>Oamaru 107.7FM<br/><br/>countryradionetwork.com")
);

categories["Toroa Radio"]=new Array (
    new Station("Toroa Radio", "http://www.accessradio.org/media/live/listen.asx?stream=13", "Otago community access radio<br/><br/>1575AM<br/><br/>toroaradio.co.nz")
);

categories["Radio Dunedin"]=new Array (
    new Station("Radio Dunedin", "http://www1.streaming.net.nz/meta/tvworks-radun.asx", "Dunedin local radio<br/><br/>1305AM & 99.8FM<br/><br/>radiodunedin.co.nz")
);

images = new Object;
images["Radio New Zealand"]="RNZ.png";
images["bFM"]="bFM.png";
images["Southern Star"]="SouthernStar.png";
images["MoreFM"]="moreFM.png";
images["BSport"]="BSport.png";
images["Coast Timeless Music"]="Coast.png";
images["Easy Mix"]="EasyMix.png";
images["Flava"]="Flava.png";
images["George FM"]="GeorgeFM.png";
images["Kiwi FM"]="KiwiFM.png";
images["Newstalk ZB"]="NewstalkZB.png";
images["Radio Hauraki"]="RadioHauraki.png";
images["Radio Live"]="RadioLive.png";
images["Radio Sport"]="RadioSport.png";
images["Solid Gold"]="SolidGold.png";
images["The Edge"]="Edge.png";
images["The Rock"]="Rock.png";
images["ZM"]="ZM.png";
images["Life fm"]="Lifefm.png";
images["Niu FM"]="Niu.png";
images["Rhema"]="Rhema.png";
images["UGM"]="UGM.png";
images["Classic Hits"]="ClassicHits.png";
images["The Breeze"]="breeze.png";
images["The Zone"]="Zone.png";
images["Big FM"]="BigFM.png";
images["Fleet FM"]="Fleet.png";
images["Mai FM"]="Mai.png";
images["Radio 531 PI"]="531PI.png";
images["Radio Tarana"]="Tarana.png";
images["Static"]="Static.png";
images["Up FM"]="Up.png";
images["Waiheke Radio"]="Waiheke.png";
images["Community Radio Hamilton"]="CRH.png";
images["1XX"]="1XX.png";
images["BayRock"]="BayRock.png";
images["Access Radio Manawatu"]="ARM.png";
images["Radio Control"]="RadioControl.png";
images["The VBC"]="VBC.png";
images["Human FM"]="Human.png";
images["Radio Active"]="Active.png";
images["Wellington Access Radio"]="WAR.png";
images["BayRock"]="BayRock.png";
images["Access Radio Manawatu"]="ARM.png";
images["Radio Control"]="RadioControl.png";
images["The VBC"]="VBC.png";
images["fresh fm"]="fresh.png";
images["pulzar fm"]="pulzar.png";
images["RDU 98.5 FM"]="RDU.png";
images["Plains FM"]="Plains.png";
images["New Zealand Country Radio"]="NZCR.png";
images["Toroa Radio"]="Toroa.png";
images["Radio Dunedin"]="RadioDunedin.png";

function NewZealandRadio()
{
    ScriptableServiceScript.call( this, "New Zealand Radio", 2, "New Zealand Radio Streams", false );
    Amarok.debug( "ok." );
}

function onConfigure()
{
    Amarok.alert( "Este script no requiere configuración." );
}

function onPopulating( level, callbackData, filter )
{
    if ( level == 1 ) 
    {
        for( att in categories )
        {
            var cover = Amarok.Info.scriptPath() + "/" + images[att];
            Amarok.debug ("att: " + att + ", " + categories[att].name);
      
            item = Amarok.StreamItem;
	    item.level = 1;
	    item.callbackData = att;
	    item.itemName = att;
	    item.playableUrl = "";
	    item.infoHtml = "";
            item.coverUrl = cover;
	    script.insertItem( item );

        }
        script.donePopulating();

    }
    else if ( level == 0 ) 
    {
        Amarok.debug( " Recopilando emisoras..." );
	//add the station streams as leaf nodes

        var stationArray = categories[callbackData];

	for ( i = 0; i < stationArray.length; i++ )
	{
                var cover = Amarok.Info.scriptPath() + "/" + images[callbackData];
		item = Amarok.StreamItem;
		item.level = 0;
		item.callbackData = "";
		item.itemName = stationArray[i].name;
		item.playableUrl = stationArray[i].url;
		item.album = callbackData;
		item.infoHtml = stationArray[i].description;
                item.artist = "";
                item.coverUrl = cover;
		script.insertItem( item );
	}
	script.donePopulating();
    }
}

function onCustomize() {
    var currentDir = Amarok.Info.scriptPath() + "/";
    var iconPixmap = new QPixmap(currentDir+"icon.png");
    script.setIcon(iconPixmap);
}

Amarok.configured.connect( onConfigure );

script = new NewZealandRadio();
script.populate.connect( onPopulating );
script.customize.connect( onCustomize );
